import React, { Component } from 'react';
import axios from 'axios';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var getUsernameFromGistUrl = function getUsernameFromGistUrl(userName) {
  return Promise.resolve("https://api.github.com/users/" + userName);
}; //   gistUrl = String(gistUrl);

var GitUserInfo = /*#__PURE__*/function (_Component) {
  _inheritsLoose(GitUserInfo, _Component);
  function GitUserInfo(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.state = {
      avatarUrl: '',
      name: ''
    };
    return _this;
  }
  var _proto = GitUserInfo.prototype;
  _proto.componentDidMount = function componentDidMount() {
    try {
      var _this2 = this;
      var _temp = _catch(function () {
        var _get = axios.get;
        return Promise.resolve(getUsernameFromGistUrl(_this2.props.gistUsername)).then(function (_getUsernameFromGistU) {
          return Promise.resolve(_get.call(axios, _getUsernameFromGistU)).then(function (response) {
            var _response$data = response.data,
              avatar_url = _response$data.avatar_url,
              name = _response$data.name;
            _this2.setState({
              avatarUrl: avatar_url,
              name: name
            });
          });
        });
      }, function (error) {
        console.error('Error fetching user information:', error);
      });
      return Promise.resolve(_temp && _temp.then ? _temp.then(function () {}) : void 0);
    } catch (e) {
      return Promise.reject(e);
    }
  };
  _proto.render = function render() {
    var _this$state = this.state,
      avatarUrl = _this$state.avatarUrl,
      name = _this$state.name;
    return React.createElement("div", null, avatarUrl && React.createElement("div", {
      style: {
        display: 'flex',
        alignItems: 'center'
      }
    }, React.createElement("img", {
      src: avatarUrl,
      alt: "Avatar",
      style: {
        width: 30,
        height: 30,
        borderRadius: '50%'
      }
    }), React.createElement("p", {
      style: {
        padding: '5px'
      }
    }, "Gist By. ", name)));
  };
  return GitUserInfo;
}(Component);

var CreateIframe = function CreateIframe(_ref) {
  var iframeRef = _ref.iframeRef,
    width = _ref.width,
    height = _ref.height,
    file = _ref.file,
    id = _ref.id;
  return React.createElement("iframe", {
    ref: iframeRef,
    width: width,
    height: height,
    src: file,
    id: id
  });
};

var GitGist = /*#__PURE__*/function (_Component) {
  _inheritsLoose(GitGist, _Component);
  function GitGist(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.iframeRef = React.createRef();
    _this.state = {
      gistLink: ''
    };
    return _this;
  }
  var _proto = GitGist.prototype;
  _proto.componentDidMount = function componentDidMount() {
    this.updateGistLink();
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (this.props.id !== prevProps.id || this.props.file !== prevProps.file) {
      this.updateGistLink();
    }
  };
  _proto.createGitGistUrl = function createGitGistUrl(id, file) {
    var baseUrl = 'https://gist.github.com/';
    var fileArg = file ? "?file=" + file : '';
    return "" + baseUrl + id + ".js" + fileArg;
  };
  _proto.updateGistLink = function updateGistLink() {
    var link = this.createGitGistUrl(this.props.id, this.props.file);
    this.setState({
      gistLink: link
    }, this.updateIframeContent);
  };
  _proto.updateIframeContent = function updateIframeContent() {
    var _iframe$contentWindow;
    var iframe = this.iframeRef.current;
    if (!iframe) return;
    var doc = (_iframe$contentWindow = iframe.contentWindow) === null || _iframe$contentWindow === void 0 ? void 0 : _iframe$contentWindow.document;
    if (!doc) return;
    var html = "<script type=\"text/javascript\" src=\"" + this.state.gistLink + "\"></script>";
    doc.open();
    doc.write(html);
    doc.close();
  };
  _proto.render = function render() {
    var _this$props = this.props,
      _this$props$width = _this$props.width,
      width = _this$props$width === void 0 ? '100%' : _this$props$width,
      _this$props$height = _this$props.height,
      height = _this$props$height === void 0 ? '600px' : _this$props$height,
      _this$props$getProfil = _this$props.getProfile,
      getProfile = _this$props$getProfil === void 0 ? 'false' : _this$props$getProfil,
      _this$props$userName = _this$props.userName,
      userName = _this$props$userName === void 0 ? '' : _this$props$userName;
    return React.createElement("div", null, getProfile === 'true' && React.createElement(GitUserInfo, {
      gistUsername: userName
    }), React.createElement(CreateIframe, {
      iframeRef: this.iframeRef,
      width: width,
      height: height,
      file: this.props.file,
      id: this.props.id
    }));
  };
  return GitGist;
}(Component);

export default GitGist;
//# sourceMappingURL=react-nextjs-github-gist.esm.js.map
